[![Version](https://img.shields.io/pypi/v/awsmate)](https://pypi.org/project/awsmate/ "Project page - PyPI")
[![Python](https://img.shields.io/pypi/pyversions/awsmate)](https://github.com/shlublu/awsmate/tree/master/src/awsmate "Source code - Github")
[![License](https://img.shields.io/github/license/shlublu/awsmate)](https://github.com/shlublu/awsmate/blob/master/LICENSE.txt "License - Github")
[![Tests](https://github.com/shlublu/awsmate/actions/workflows/tests.yaml/badge.svg?branch=master)](https://github.com/shlublu/awsmate/actions "Workflows - Github")
[![Documentation](https://readthedocs.org/projects/awsmate/badge/?version=latest)](https://awsmate.readthedocs.io/ "Documentation - ReadTheDocs.io")


`awsmate` is a companion for your AWS developments in Python.
It provides you with helper code that facilitates the use of various AWS services.

## What it is, what it does

`awsmate` pools AWS specific code that is rewriten and retested for each new project:
* it simplifies the use of some AWS services
* it simplifies the error handling related to the use of these services

`awsmate` does not do what others have already done and sticks to simplifying the use of AWS:
* it does not replace existing major libraries such as [s3fs](https://s3fs.readthedocs.io/en/latest/), [pynamodb](https://pynamodb.readthedocs.io/en/latest/), [aws-lambda-powertools](https://pypi.org/project/aws-lambda-powertools/) or [boto3](https://boto3.amazonaws.com/v1/documentation/api/latest/index.html)
* it does not implement functional use cases or algorithms

## Installation

* Command line: `pip3 install awsmate`
* [PyPI page](https://pypi.org/project/awsmate/ "PyPI page")

## Documentation

The complete documentation is available at [ReadTheDocs](https://awsmate.readthedocs.io/ "Documentation - ReadTheDocs.io").

## Example application

An example application is available to demonstrate the main features of this library. It is documented [in this chapter](https://awsmate.readthedocs.io/en/latest/example_application.html).

## Issues

Should you encounter any bug or problem of any kind, please feel free to open an issue according to our [contribution guidelines](https://awsmate.readthedocs.io/en/latest/contributing.html).

## License

This project is licensed under the EUROPEAN UNION PUBLIC LICENCE (EUPL) v. 1.2, which is compatible with the majority of open source licences.

* [View all translations](https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12 "Translations of the EUPL-1.2")
* [OSI Compatibility matrix](https://joinup.ec.europa.eu/collection/eupl/matrix-eupl-compatible-open-source-licences "Compatibility matrix of the EUPL-1.2")
